// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_common_msgs:msg/CameraParam.idl
// generated code does not contain a copyright notice

#ifndef RC_COMMON_MSGS__MSG__DETAIL__CAMERA_PARAM__TRAITS_HPP_
#define RC_COMMON_MSGS__MSG__DETAIL__CAMERA_PARAM__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rc_common_msgs/msg/detail/camera_param__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'line_source'
// Member 'extra_data'
#include "rc_common_msgs/msg/detail/key_value__traits.hpp"

namespace rc_common_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const CameraParam & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: is_color_camera
  {
    out << "is_color_camera: ";
    rosidl_generator_traits::value_to_yaml(msg.is_color_camera, out);
    out << ", ";
  }

  // member: exposure_time
  {
    out << "exposure_time: ";
    rosidl_generator_traits::value_to_yaml(msg.exposure_time, out);
    out << ", ";
  }

  // member: gain
  {
    out << "gain: ";
    rosidl_generator_traits::value_to_yaml(msg.gain, out);
    out << ", ";
  }

  // member: line_status_all
  {
    out << "line_status_all: ";
    rosidl_generator_traits::value_to_yaml(msg.line_status_all, out);
    out << ", ";
  }

  // member: line_source
  {
    if (msg.line_source.size() == 0) {
      out << "line_source: []";
    } else {
      out << "line_source: [";
      size_t pending_items = msg.line_source.size();
      for (auto item : msg.line_source) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: extra_data
  {
    if (msg.extra_data.size() == 0) {
      out << "extra_data: []";
    } else {
      out << "extra_data: [";
      size_t pending_items = msg.extra_data.size();
      for (auto item : msg.extra_data) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CameraParam & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: is_color_camera
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "is_color_camera: ";
    rosidl_generator_traits::value_to_yaml(msg.is_color_camera, out);
    out << "\n";
  }

  // member: exposure_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "exposure_time: ";
    rosidl_generator_traits::value_to_yaml(msg.exposure_time, out);
    out << "\n";
  }

  // member: gain
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gain: ";
    rosidl_generator_traits::value_to_yaml(msg.gain, out);
    out << "\n";
  }

  // member: line_status_all
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "line_status_all: ";
    rosidl_generator_traits::value_to_yaml(msg.line_status_all, out);
    out << "\n";
  }

  // member: line_source
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.line_source.size() == 0) {
      out << "line_source: []\n";
    } else {
      out << "line_source:\n";
      for (auto item : msg.line_source) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: extra_data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.extra_data.size() == 0) {
      out << "extra_data: []\n";
    } else {
      out << "extra_data:\n";
      for (auto item : msg.extra_data) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CameraParam & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rc_common_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_common_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_common_msgs::msg::CameraParam & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_common_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_common_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const rc_common_msgs::msg::CameraParam & msg)
{
  return rc_common_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rc_common_msgs::msg::CameraParam>()
{
  return "rc_common_msgs::msg::CameraParam";
}

template<>
inline const char * name<rc_common_msgs::msg::CameraParam>()
{
  return "rc_common_msgs/msg/CameraParam";
}

template<>
struct has_fixed_size<rc_common_msgs::msg::CameraParam>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_common_msgs::msg::CameraParam>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_common_msgs::msg::CameraParam>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RC_COMMON_MSGS__MSG__DETAIL__CAMERA_PARAM__TRAITS_HPP_
